> For the complete documentation index, see [llms.txt](https://docs.apryse.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.apryse.com/xamarin/guides/viewer-components/list-container.md).

# Display & customize list container in Xamarin

Learn how to implement a list container in Xamarin.Android for displaying tabs like Annotation list, Document outline, and User-defined bookmark list. Customize your BookmarksDialogFragment with ease.

{% hint style="info" %}
**This tutorial only applies to Xamarin.Android. See Xamarin.iOS equivalent here .**
{% endhint %}

The list container provides a horizontal layout to display the following items in separate tabs:

* [Annotation list](/xamarin/annotation/annotation-list.md#android)
* [Document outline](/xamarin/guides/android/bookmark/outline.md#ui-component)
* [User-defined bookmark list](/xamarin/bookmarks/user-bookmarks.md#android)

![](https://653871032-files.gitbook.io/~/files/v0/b/gitbook-x-prod.appspot.com/o/spaces%2FgjsBtuYmcKhWOdM9VCg4%2Fuploads%2Fgit-blob-3769c92bdcad1d5b53edbb5cd4dc409efcd4329a%2F408eaa5f033c0bd4620b5e20efcea346589a7c84-600x1200.gif?alt=media)

## Show list container

The list container is implemented by the `BookmarksDialogFragment` class. To show this fragment in your activity, create a new instance of `BookmarksDialogFragment` by calling `newInstance()`. Afterwards, initialize your fragment by setting the [`PDFViewCtrl`](https://sdk.apryse.com/api/xamarinandroid/pdfnet/api/pdftron.PDF.PDFViewCtrl.html) and an `ArrayList` of `DialogFragmentTab`:

{% tabs %}
{% tab title="C#" %}
{% code lineNumbers="true" %}

```csharp
private PDFViewCtrl mPdfViewCtrl;
// ...
public void ShowBookmarksDialog(List<DialogFragmentTab> dialogFragmentTabs,
                                FragmentManager fragmentManager) {
    var fragment = BookmarksDialogFragment.NewInstance();
    fragment.SetPdfViewCtrl(mPdfViewCtrl)
            .SetDialogFragmentTabs(dialogFragmentTabs);
    // Set a custom style for this fragment
    fragment.SetStyle((int)DialogFragmentStyle.NoTitle, Resource.Style.PDFTronAppTheme);
    // Show the dialog
    fragment.Show(fragmentManager, "bookmarks_dialog");
}
```

{% endcode %}
{% endtab %}
{% endtabs %}

`DialogFragmentTab` specifies the information about each tab including the type of class and the tab tag. Currently the following dialogs can be displayed within the bookmarks dialog:

| Dialog             | Type of class                    | Tab tag              |
| ------------------ | -------------------------------- | -------------------- |
| Annotation list    | AnnotationDialogFragment.class   | TAG\_TAB\_ANNOTATION |
| Document outline   | OutlineDialogFragment.class      | TAG\_TAB\_OUTLINE    |
| User bookmark list | UserBookmarkDialogFragment.class | TAG\_TAB\_BOOKMARK   |

The following example shows how to display an annotations list, a document outline, and a user-defined bookmark list tabs in `BookmarksDialogFragment`:

{% tabs %}
{% tab title="C#" %}
{% code lineNumbers="true" %}

```csharp
using pdftron.PDF.Tools.Utils;

var bookmarksDialog = pdftron.PDF.Dialog.BookmarksDialogFragment.NewInstance();
bookmarksDialog.SetPdfViewCtrl(mPdfViewCtrl);
List<DialogFragmentTab> tabs = new List<DialogFragmentTab>();
var annotationsTab = new DialogFragmentTab(
    Java.Lang.Class.FromType(typeof(AnnotationDialogFragment)), BookmarksTabLayout.TagTabAnnotation, null, "Annotations", "Bookmarks Dialog", null);
var outlineDialog = new DialogFragmentTab(
    Java.Lang.Class.FromType(typeof(OutlineDialogFragment)), BookmarksTabLayout.TagTabOutline, null, "Outline", "Bookmarks Dialog", null);
var userBookmarksDialog = new DialogFragmentTab(
    Java.Lang.Class.FromType(typeof(UserBookmarkDialogFragment)), BookmarksTabLayout.TagTabBookmark, null, "User Bookmarks", "Bookmarks Dialog", null);
tabs.Add(annotationsTab);
tabs.Add(outlineDialog);
tabs.Add(userBookmarksDialog);
bookmarksDialog.SetDialogFragmentTabs(tabs);
bookmarksDialog.SetStyle((int)DialogFragmentStyle.NoTitle, Resource.Style.PDFTronAppTheme);
bookmarksDialog.Show(this.SupportFragmentManager, "bookmarks_dialog");
bookmarksDialog.AnnotationClicked += (sender, e) =>
{
    bookmarksDialog.Dismiss();
};
bookmarksDialog.ExportAnnotations += (sender, e) =>
{
    // handle export annotations here
    bookmarksDialog.Dismiss();
};
bookmarksDialog.OutlineClicked += (sender, e) =>
{
    bookmarksDialog.Dismiss();
};
bookmarksDialog.UserBookmarkClick += (sender, e) =>
{
    mPdfViewCtrl.SetCurrentPage(e.PageNum);
    bookmarksDialog.Dismiss();
};
```

{% endcode %}
{% endtab %}
{% endtabs %}

## Customization

The `BookmarksDialogFragment` provides a flexible API for displaying only the desired child view. Any of the annotation list, document outline, or user-defined bookmark list view can be removed by omitting them from the `DialogFragmentTabs`.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.apryse.com/xamarin/guides/viewer-components/list-container.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
